package m200.messages;

import java.util.HashMap;

import m200.exceptions.M200MsgClassNotEqMsgTypeException;
import m200.transceiver.M200MessageBody;

public class M200MsgFactory {
	private static class MsgType2Class{
		public HashMap<Integer,M200Msg> map;
		public MsgType2Class(){
			map=new HashMap<Integer,M200Msg>();
			map.put(10,new M200MsgSeizure());
			map.put(11,new M200MsgNumber());
			map.put(12,new M200MsgAccept());
			map.put(13,new M200MsgCall());
			map.put(15,new M200MsgRelease());
			map.put(16,new M200MsgRelease());
			map.put(20,new M200MsgInt());
			map.put(21,new M200MsgInt());
			map.put(22,new M200MsgInt());
			map.put(23,new M200MsgInt());
			map.put(40,new M200MsgInt());
		}
	}
	private static final MsgType2Class msgType2Class=new MsgType2Class();
	public static M200Msg instance(M200MessageBody mb) throws M200MsgClassNotEqMsgTypeException{
		M200Msg m=msgType2Class.map.get(mb.msgType);
		M200Msg ret;
		if(m==null) ret=(M200Msg)(new M200MsgCommon());
		else ret=m.cloneNew();
		ret.setBody(mb);
		return ret;
	}
}
