package m200.messages;

import m200.exceptions.M200MsgClassNotEqMsgTypeException;
import m200.transceiver.M200Util;


public class M200MsgNumber extends M200Msg {
	 // number:STRING aon:STRING
	private static final int TYPE=11;
	private String to;
	private String from;
	
	protected boolean isTypeValid(){
		return (TYPE==body.msgType);
	}
	public M200Msg cloneNew(){
		 return new M200MsgNumber(); 
	}
	public String toString(){
		return super.toString()+" "+" n:"+to+" a:"+from+
		" x:"+body.data[body.HEADERLEN+M200Util.getString(body.data,body.HEADERLEN).length()+1+M200Util.getString(body.data,body.HEADERLEN+M200Util.getString(body.data,body.HEADERLEN).length()+1).length()+1];
	}
	public static int getType() {
		return TYPE;
	}
	public String toHumanString() {
		return super.toHumanString()+" t:"+to+" f:"+from;
	}
	public static M200MsgNumber cast(M200Msg msg) throws M200MsgClassNotEqMsgTypeException {
		try{
			return M200MsgNumber.class.cast(msg);
		}catch (ClassCastException e){
			throw new M200MsgClassNotEqMsgTypeException(M200MsgNumber.class.getSimpleName(),msg);
		}
	}
	public String getNumberTo() {
		return to;
	}
	public String getNumberFrom() {
		return from;
	}
	@Override
	protected void bodyReady() {
		to=M200Util.getString(body.data,body.HEADERLEN);
		from=M200Util.getString(body.data,body.HEADERLEN+to.length()+1);
	}

}
