package m200.messages;

import m200.exceptions.M200MsgClassNotEqMsgTypeException;
import m200.transceiver.M200Util;


//RELEASE_IN/RELEASE_OUT

public class M200MsgRelease extends M200Msg { 
	 // reason:BYTE
	String hStr;
	protected boolean isTypeValid(){
		return (15==body.msgType||16==body.msgType);
	}
	public M200Msg cloneNew(){
		 return new M200MsgRelease(); 
	}
	public String toString(){
		return super.toString()+" "+M200Util.cause2Str(body.data[body.HEADERLEN])+"("+body.data[body.HEADERLEN]+")";
	}
	public String toHumanString(){
		return super.toHumanString()+" "+hStr;
	}
	@Override
	protected void bodyReady() {
		hStr=M200Util.cause2HStr(body.data[body.HEADERLEN])+"("+body.data[body.HEADERLEN]+")";
	}
	public static M200MsgRelease cast(M200Msg msg) throws M200MsgClassNotEqMsgTypeException {
		try{
			return M200MsgRelease.class.cast(msg);
		}catch (ClassCastException e){
			throw new M200MsgClassNotEqMsgTypeException(M200MsgRelease.class.getSimpleName(),msg);
		}
	}
	public String getCauseStr() {
		return hStr;
	}
	public int getCause() {
		return body.data[body.HEADERLEN];
	}

}
