package m200.transceiver;

import java.util.HashMap;

public class M200Util {
	private static class MsgType2String{
		public HashMap<Integer, String[]> map;
		public MsgType2String(){
			map=new HashMap<Integer, String[]>();
			map.put(1,new String[]{"MON_ALIVE","Alive"}); //сохранена последовательность из monmessage.h
			map.put(2,new String[]{"MON_SPIDER_START",""});
			map.put(3,new String[]{"MON_SPIDER_MODULE_UP",""});
			map.put(4,new String[]{"MON_SPIDER_MODULE_DOWN",""});
			map.put(5,new String[]{"MON_SPIDER_TCP_UP",""});
			map.put(6,new String[]{"MON_SPIDER_TCP_DOWN",""});
			map.put(7,new String[]{"MON_SPIDER_USER_STOP",""});
			map.put(8,new String[]{"MON_SPIDER_INFO",""});
			map.put(9,new String[]{"MON_SPIDER_INFO_EX",""});
			map.put(60,new String[]{"MON_SPIDER_BAD_PACKET",""});
			map.put(61,new String[]{"MON_SPIDER_GATE_LOST",""});
			map.put(10,new String[]{"MON_SEIZURE","Seiz"});
			map.put(11,new String[]{"MON_NUMBER","Num"});
			map.put(12,new String[]{"MON_ACCEPT","Acc"});
			map.put(13,new String[]{"MON_CALL","Call"});
			map.put(14,new String[]{"MON_ANSWER","Ans"});
			map.put(15,new String[]{"MON_RELEASE_IN","rIn"});
			map.put(16,new String[]{"MON_RELEASE_OUT","rOut"});
			map.put(17,new String[]{"MON_COMBINE",""});
			map.put(18,new String[]{"MON_COMOVERLOAD",""});
			map.put(24,new String[]{"MON_WIZOVERLOAD",""});
			map.put(25,new String[]{"MON_FATOVERLOAD",""});
			map.put(19,new String[]{"MON_TIMECHANGE",""});
			map.put(50,new String[]{"MON_DVO_REDIRECT",""});
			map.put(51,new String[]{"MON_HOLDEND",""});
			map.put(20,new String[]{"MON_INT_CALL_OUT","ICO"});
			map.put(21,new String[]{"MON_INT_CALL_IN","ICI"});
			map.put(22,new String[]{"MON_INT_RLS_OUT","IRO"});
			map.put(23,new String[]{"MON_INT_RLS_IN","IRI"});
			map.put(30,new String[]{"MON_LINK_STATE",""});
			map.put(40,new String[]{"MON_PORT_FREE",""});
		}
	}
	private static class Signaling2String{
		public HashMap<Integer, String[]> map;
		public Signaling2String(){
			map=new HashMap<Integer, String[]>();
			map.put(2,new String[]{"SIGNALLING_DSS1","DSS1"}); //выборка из unipar.h
			map.put(16,new String[]{"SIGNALLING_ISUP","ISUP"});
		}
	}
	private static class ReleaseCause2String{
		public HashMap<Integer, String[]> map;
		public ReleaseCause2String(){
			map=new HashMap<Integer, String[]>();
			map.put(1,new String[]{"ReleaseCause_Unallocated_number","UnallocatedNumber"}); //сохранена последовательность из unipar.h
			map.put(2,new String[]{"ReleaseCause_No_route_to_transit_network","NoRouteToTransitNetwork"});
			map.put(3,new String[]{"ReleaseCause_No_route_to_destination","NoRouteToDestination"});
			map.put(6,new String[]{"ReleaseCause_Channel_unacceptable","ChannelUnacceptable"});
			map.put(7,new String[]{"ReleaseCause_Call_awarded","CallAwarded"});
			map.put(8,new String[]{"ReleaseCause_Preemption","Preemption"});
			map.put(16,new String[]{"ReleaseCause_Normal_call_clearing","NormalCallClearing"});
			map.put(17,new String[]{"ReleaseCause_User_busy","UserBusy"});
			map.put(18,new String[]{"ReleaseCause_No_user_responding","NoUserResponding"});
			map.put(19,new String[]{"ReleaseCause_No_answer_from_user","NoAnswerFromUser"});
			map.put(20,new String[]{"ReleaseCause_Subscriber_absent","SubscriberAbsent"});
			map.put(21,new String[]{"ReleaseCause_Call_rejected","CallRejected"});
			map.put(22,new String[]{"ReleaseCause_Number_changed","NumberChanged"});
			map.put(25,new String[]{"ReleaseCause_Exchange_routing_error","ExchangeRoutingError"});
			map.put(26,new String[]{"ReleaseCause_Non_selected_user_clearing","NonSelectedUserClearing"});
			map.put(27,new String[]{"ReleaseCause_Destination_out_of_order","DestinationOutOfOrder"});
			map.put(28,new String[]{"ReleaseCause_Invalid_number_format","InvalidNumberFormat"});
			map.put(29,new String[]{"ReleaseCause_Facility_rejected","FacilityRejected"});
			map.put(30,new String[]{"ReleaseCause_Response_to_STATUS_ENQUIRY","ResponseToStatusEnquiry"});
			map.put(31,new String[]{"ReleaseCause_Normal_unspecified","NormalUnspecified"});
			map.put(34,new String[]{"ReleaseCause_No_circuit_channel_available","NoCircuitChannelAvailable"});
			map.put(38,new String[]{"ReleaseCause_Network_out_of_order","NetworkOutOfOrder"});
			map.put(41,new String[]{"ReleaseCause_Temporary_failure","TemporaryFailure"});
			map.put(42,new String[]{"ReleaseCause_Switching_equipment_congestion","SwitchingEquipmentCongestion"});
			map.put(43,new String[]{"ReleaseCause_Access_information_discarded","AccessInformationDiscarded"});
			map.put(44,new String[]{"ReleaseCause_Reqsted_channel_not_available","RequestedChannelNotAvailable"});
			map.put(46,new String[]{"ReleaseCause_Precedence_call_blocked","PrecedenceCallBlocked"});
			map.put(47,new String[]{"ReleaseCause_Resource_unavailable_unspecif","ResourceUnavailableUnspecif"});
			map.put(49,new String[]{"ReleaseCause_Quality_of_service_unavailable","QualityOfServiceUnavailable"});
			map.put(50,new String[]{"ReleaseCause_Reqsted_facility_not_subscribed","RequestedFacilityNotSubscribed"});
			map.put(57,new String[]{"ReleaseCause_Bearer_capability_not_authrzed","BearerCapabilityNotAuthorized"});
			map.put(58,new String[]{"ReleaseCause_Bearer_capability_not_available","BearerCapabilityNotAvailable"});
			map.put(63,new String[]{"ReleaseCause_Service_not_available_unspec","ServiceNotAvailableUnspec"});
			map.put(65,new String[]{"ReleaseCause_Bearer_capability_not_implmted","BearerCapabilityNotImplmted"});
			map.put(66,new String[]{"ReleaseCause_Channel_type_not_implemented","ChannelTypeNotImplemented"});
			map.put(69,new String[]{"ReleaseCause_Reqsted_facility_not_implmted","ReqstedFacilityNotImplmted"});
			map.put(70,new String[]{"ReleaseCause_Only_restricted_digital_bearer","OnlyRestrictedDigitalBearer"});
			map.put(79,new String[]{"ReleaseCause_Service_not_implemented","ServiceNotImplemented"});
			map.put(81,new String[]{"ReleaseCause_Invalid_call_reference_value","InvalidCallReferenceValue"});
			map.put(82,new String[]{"ReleaseCause_Identified_channel_not_exist","IdentifiedChannelNotExist"});
			map.put(83,new String[]{"ReleaseCause_No_call_ID_for_suspended_call","NoCallIDforSuspendedCall"});
			map.put(84,new String[]{"ReleaseCause_Call_identity_in_use","CallIdentityInUse"});
			map.put(85,new String[]{"ReleaseCause_No_call_suspended","NoCallSuspended"});
			map.put(86,new String[]{"ReleaseCause_Call_has_been_cleared","CallHasBeenCleared"});
			map.put(87,new String[]{"ReleaseCause_User_not_a_member_of_CUG","UserNotAMemberOfCUG"});
			map.put(88,new String[]{"ReleaseCause_Non_existent_closed_user_group","NonExistentClosedUserGroup"});
			map.put(89,new String[]{"ReleaseCause_Called_user_not_member_of_GUG","CalledUserNotMemberOfGUG"});
			map.put(90,new String[]{"ReleaseCause_Called_user_belongs_to_GUG","CalledUserBelongsToGUG"});
			map.put(91,new String[]{"ReleaseCause_Invalid_transit_network","InvalidTransitNetwork"});
			map.put(95,new String[]{"ReleaseCause_Invalid_message_unspecified","InvalidMessageUnspecified"});
			map.put(96,new String[]{"ReleaseCause_Mandatory_IE_is_missing","MandatoryIEisMissing"});
			map.put(97,new String[]{"ReleaseCause_Messsage_type_non_existent","MesssageTypeNonExistent"});
			map.put(98,new String[]{"ReleaseCause_Msg_uncompatible_non_existent","MsgUncompatibleNonExistent"});
			map.put(99,new String[]{"ReleaseCause_IE_non_existent","IEnonExistent"});
			map.put(100,new String[]{"ReleaseCause_Invalid_IE_contents","InvalidIEcontents"});
			map.put(101,new String[]{"ReleaseCause_Message_not_compatible","MessageNotCompatible"});
			map.put(102,new String[]{"ReleaseCause_Recovery_on_timer_expiry","RecoveryOnTimerExpiry"});
			map.put(111,new String[]{"ReleaseCause_Protocol_error_unspecified","ProtocolErrorUnspecified"});
			map.put(127,new String[]{"ReleaseCause_Interworking_unspecified","InterworkingUnspecified"});
		}
	}
private static final MsgType2String msgType2String=new MsgType2String();   
private static final Signaling2String sig2String=new Signaling2String();
private static final ReleaseCause2String cause2String=new ReleaseCause2String();
public static  int getDWORD(byte[] b){
	if(b.length!=4){
		System.err.print("Error b.length!=4");
		return -1;
	}
	int l=0;
	for(int i=0;i<b.length;i++){
		//System.err.print("<"+Integer.toHexString(b[i])+">");
		l|=((b[i]<0)?(256+(int)b[i]):(int)b[i])<<(8*i); //?????????????
	}
/*	System.err.print("="+ l);
	System.err.println();
	System.err.flush();
	*/
	return l;
}
public static long getDWORD(byte[] b, int pos) {
	long l=0;
	for(int i=0;i<4;i++){
		l|=((long)((b[pos+i]<0)?(256+(long)b[pos+i]):(long)b[pos+i]))<<(8*i); //?????????????
	}
	return l;
}

public static int byte2int(byte b) {
	return (b<0)?256+(int)b:b;
}
protected static String msgType2String(int t,int i){
	String[] s=msgType2String.map.get(t);
	return (s==null)?""+t:s[i];
}
public static String msgType2Str(int t){
	return msgType2String(t,0);
}
public static String msgType2HStr(int t) {
	return msgType2String(t,1);
}


protected static String sig2String(int t,int i){
	String[] s=sig2String.map.get(t);
	return (s==null)?""+t:s[i];
}

public static String sig2Str(int t){
	return sig2String(t,0);
}

public static String sig2HStr(int t){
	return sig2String(t,1);
}

protected static String cause2String(int t,int i){
	String[] s=cause2String.map.get(t);
	return (s==null)?""+t:s[i];
}

public static String cause2Str(int t){
	return cause2String(t,0);
}

public static String cause2HStr(int t){
	return cause2String(t,1);
}


public static String getString(byte[] b, int pos) {
	int i=pos;
	for(;i<b.length;i++) if(b[i]==0) break;
	if(i>=b.length) return new String("none");
	return new String(b,pos,i-pos);
}
}